<script setup lang="ts">
    import { useDisplay } from 'vuetify'
    import { computed, ref } from 'vue'

    export interface Props {
        expanded?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        expanded: true,
    })

    const emit = defineEmits<{
        (e: 'click:icon'): void
    }>()

    const textField = ref()
    const input = computed<HTMLInputElement>(() =>
        textField.value?.$el.querySelector(
            'input:not([type=hidden]),textarea:not([type=hidden])'
        )
    )

    const focus = () => {
        if (input.value) {
            window.setTimeout(() => {
                input.value.focus()
            }, 0)
        }
    }

    const { mobile } = useDisplay()
    const fullWidth = computed(() => !(props.expanded && mobile.value))

    defineExpose({
        focus,
        fullWidth,
    })

    defineOptions({
        inheritAttrs: false,
    })
</script>
<template>
    <v-row
        :class="[
            'search-field-container',
            'shrink',
            expanded && 'expanded',
            mobile && 'mobile',
        ]"
    >
        <div class="search-bar">
            <v-btn
                v-if="!mobile ? expanded : !expanded"
                icon="mdi-magnify"
                :disabled="!mobile && expanded"
                variant="plain"
                data-cy="button-open-search-user"
                @click="emit('click:icon')"
            />
            <v-expand-x-transition>
                <v-text-field
                    v-show="expanded"
                    ref="textField"
                    v-bind="$attrs"
                    class="search-field"
                    :class="mobile ? 'ml-5' : undefined"
                    width="100"
                    elevation="0"
                    density="compact"
                    placeholder="Rechercher..."
                    single-line
                    hide-details
                    data-cy="field-search-user"
                ></v-text-field>
            </v-expand-x-transition>
        </div>
    </v-row>
</template>
<style lang="scss">
    .search-bar {
        display: flex;
        width: 100%;
    }
    .search-field-container {
        position: absolute;
        right: 0;
        margin-right: 16px;

        &.mobile {
            position: initial;
            margin-right: 8px;
            flex: 0 1 auto;

            &.expanded {
                flex: 1 1 auto;
            }
        }

        &.expanded:not(.mobile) {
            width: 33%;
        }
    }
</style>
